## Chapter 1. QSA Utility Framework

The QSA Utility Framework is a set of classes that extends QSA to enable the user to read and write files, access directory structures and start processes synchronously and asynchronously.

## File Class Reference

The `File` class provides functionallity for reading and writing binary and text files. A `File` can be instantiated as an object, giving the scripter complete flexibility when reading and writing files. In addition, the `File` class provides a set of static convenence functions for reading and writing files in one go. Typical use of a `File` is:

    // Reads an entire file in one go
    var log = File.read('file.log');
    // Writes an entire file in one go
    File.write('copy_of_file.log', log);

    // Read and write a file line by line
    var infile = new File('file.log');
    infile.open(File.ReadOnly);

    var outfile = new File('copy_of_file.log');
    outfile.open(File.WriteOnly);

    while (!infile.eof) {
        var line = infile.readLine();
        outfile.write( line );
    }

    infile.close();
    outfile.close();

### Enums

#### AccessMode

The enum `AccessMode` is used in conjunction with `File.open` to specify the mode in which the file is opened.

- ReadOnly; Opens the file in read-only mode.

- WriteOnly; Opens the file in write-only mode. If this flag is used with `Append,` the file is not truncated; but if used on its own (or with `Truncate),` the file is truncated.

- ReadWrite; Opens the file in read/write mode. The file is not truncated.

- Append; Opens the file in append mode. (You must actually use `(WriteOnly | Append)` to make the file writable and to go into append mode.) This mode is very useful when you want to write something to a log file. The file index is set to the end of the file. Note that the result is undefined if you position the file index manually using at() in append mode.

- Truncate; Truncates the file.

- Translate; Enables carriage returns and linefeed translation for text files under Windows.

### Static Functions

- exists( fileName : String ) : Boolean; Returns true if `fileName` exists; otherwise returns false.

- remove( fileName : String ); Deletes the file `fileName` if possible; otherwise throws an exception.

- write( fileName : String, content : String ); Writes the string content to the file `fileName` if possible (completely replacing the original contents if the file already exists); otherwise throws an exception.

- read( fileName : String ) : String; Reads and returns the contents of the file `fileName` if possible; otherwise throws an exception.

- isFile( fileName : String ) : Boolean; Returns true if `fileName` is a file; otherwise returns false.

- isDir( fileName : String ) : Boolean; Returns true if `fileName` is a directory; otherwise returns false.

### Constructor

- File( fileName : String ); Creates a file object with the with fileName. If `fileName` is missing or is not a String, an exception is thrown.

### Properties

The File object's properties are read-only.

- name : String; The name of the file including the extension.

- path : String; The path of the file.

- fullName : String; The fullName of the file, including path, name, and extension.

- baseName : String; The name of the file, excluding its path and extension.

- extension : String; The file name's extension.

- symLink : String; The expansion of the symlink if the file is a symlink; otherwise empty;

- exists : Boolean; True if the file exists; otherwise false.

- readable : Boolean; True if the file is readable; otherwise false.

- writable : Boolean; True if the file is writable; otherwise false.

- executable : Boolean; True if the file is executable; otherwise false.

- hidden : Boolean; True if the file is hidden; otherwise false.

- eof : Boolean; True if reading has reached the end of the file; otherwise false.

- created : Date; The creation time of the file.

- lastModified : Date; The last modification time of the file.

- lastRead : Date; The last time the file was read.

- size : Number; The size of the file, in bytes.

### Member Functions

- open( accessMode : Number ); Opens the file in the mode accessMode if possible; otherwise throws an exception.

- close(); Closes the file.

- remove((); Deletes the file if possible; otherwise throws an exception.

- readByte() : Number; Reads one byte from the file if possible; otherwise throws an exception.

- read() : String; Returns the entire content of the file as a string if it can be read; otherwise throws an exception.

- readLine() : String; Reads one line from file if possible; otherwise throws an exception. Retains any trailing whitespace.

- readLines() : String[]; Returns the contents of the file as an array of Strings, one for each line. Linebreaks are strippped from the strings. If the file could not be read, an exception is thrown.

- writeByte( byte : Number ); Writes a byte to the file is possible; otherwise throws an exception.

- write( data : String, length : Number ); Writes `length` number of characters from `data` to the file if possible; otherwise throws an exception.

- writeLine( data : String ); Writes the line `data` to the file and adds a linebreak. If the file could not be written `error` is returned.

## Dir Class Reference

The `Dir` class provides access to directory structures and their contents in a platform-independent way. It provides a means of listing directory content, creating filenames with proper path separators, etc. An example use of the Dir class is:

    var dir = new Dir;
    var codeFiles = dir.entryList('*.cpp');
    for (var i = 0; i < codeFiles.length; ++i)
        print(codeFiles[i]);

### Enums

#### FilterSpec

This enum describes the filtering options available to Dir for entryList(). The filter value is specified by OR-ing together values from the following list.

- Dirs; List directories only.

- Files; List files only.

- Drives; List disk drives only.

- NoSymLinks; Do not list symbolic links (ignored by operating systems that don't support symbolic links).

- All; List directories, files, drives and symlinks (this does not list broken symlinks unless you specify System).

- TypeMask; A mask for the the Dirs, Files, Drives and NoSymLinks flags.

- Readable; List files for which the application has read access.

- Writable; List files for which the application has write access.

- Executable; List files for which the application has execute access. Executables must be combined with Dirs or Files.

- RWEMask; A mask for the Readable, Writable and Executable flags.

- Modified; Only list files that have been modified (ignored under Unix).

- Hidden; List hidden files (on Unix, files starting with a .).

- System; List system files (on Unix, FIFOs, sockets, and device files)

- AccessMask; A mask for the Readable, Writable, Executable Modified, Hidden and System flags

#### SortSpec

This enum describes the sort options available to Dir for entryList(). The sort value is specified by OR-ing together values from the following list:

- Name; Sort by name.

- Time; Sort by time (modification time).

- Size; Sort by file size.

- Unsorted; Do not sort.

- SortByMask; A Mask for Name, Time and Size.

- DirsFirst; Put the directories first, then the files.

- Reversed; Reverse the sort order.

- IgnoreCase; Sort case-insensitively.

### Static Properties

- current : String; The current directory.

- home : String; The home directory.

- root : String; The root directory.

- drives : String[]; An array of strings containing the drive names (c:, d:, etc); empty on Unix.

### Static Functions

Qt uses "/" as a directory separator throughout (although it understands the conventions of the platform it is used on). If you are working with paths, use "/" within your code, and use convertSeparators() when you want to display a path to the user.

- cleanDirPath( filePath : String ) : String; Removes all multiple directory separators "/" and resolves any "."s or ".."s found in the path, `filePath.`

- convertSeparators( pathName : String ) : String; Returns pathName with the "/" separators converted to separators that are appropriate for the underlying operating system.

### Constructor

- Dir( path : String ); Creates a directory object for path path. If `path` is empty, the current directory is used.

### Properties

- name : String; Contains the name of the directory; this is not the same as the path, e.g. a directory with the name "mail", might have the path "/var/spool/mail"

- path : String; Contains the path, this may contain symbolic links, but never contains redundant ".", "..", or multiple separators.

- absPath : String; Contains the absolute path (a path that starts with "/" or with a drive specification), which may contain symbolic links, but never contains redundant ".", "..", or multiple separators.

- canonicalPath : String; Contains the canonical path, i.e. a path without symbolic links or redundant "." or ".." elements.

- readable : Boolean; True if the directory is readable; otherwise false.

- exists : Boolean; True if the directory exists; otherwise false.

### Member Functions

- filePath( fileName : String ) : String; Returns the path name of the file `fileName` in the directory.

- absFilePath( fileName : String ) : String; Returns the absolute path name of the file `fileName` in the directory.

- cd( dirName : String ); Changes the Dir's directory to `dirName` if possible; otherwise throws an exception.

- cdUp(); Changes directory by moving one directory up from the Dir's current directory if possible; otherwise throws an exception.

- entryList( filter : String, filterSpec : Number, sortSpec : Number ) : String[]; Returns a list of the names of all the files and directories in the directory, ordered in accordance with `sortSpec` and filtered in accordance with `filterSpec.`

- mkdir( dirName : String ); Creates the directory `dirName` if possible; otherwise throws an exception.

- mkdir(); Creates this directory if possible possible; otherwise throws an exception.

- mkdirs( dirName : String ); Creates the directory tree `dirName` if possible; otherwise throws an exception.

- mkdirs(); Creates this directory tree if possible; otherwise throws an exception.

- rmdir( dirName : String ); Deletes the directory `dirName` if possible; otherwise throws an exception.

- rmdir(); Deletes this directory if possible; otherwise throws an exception.

- rmdirs( dirName : String ); Deletes the directory structure dirName if possible; otherwise throws an exception.

- rmdirs(); Deletes this directory structure if possible; otherwise throws an exception.

- fileExists( fileName : String ) : Boolean; Returns true if the file `fileName` exists; otherwise returns false.

- setCurrent(); Sets the application's current working directory to this directory if possible; otherwise throws an exception.

## Process Class Reference

The Process class is used to start external programs and to communicate with them. The Process class can start programs synchronously using `Process.execute(),` and asynchronously using `{new` Process(...).start()}.

### Static Properties

- stdout : String; Contains the data sent to `stdout` during the last call to `Process.execute().` This property is read-only.

- stderr : String; Contains the data sent to `stderr` during the last call to `Process.execute().` This property is read-only.

### Static Functions

- execute( command : String, stdin : String ); Executes `command` synchronously and passes `stdin` to its standard input if specified. When the program ends its output is accessible through Process.stdout and `Process.stderr.` `command` can contain both the program and command line arguments, e.g. `"ls -la"` . The function returns the executed commands return code on exit.

- execute( command : String[], stdin : String ); Same as above, except that `command` is an array of strings, where the first item is the name of the program and the following items are command line arguments. This version is useful if you have arguments that contain spaces or other characters that would need to be quoted if you just passed a single string command line, since it takes care of the quoting for you. Note that if the user passes an array of only one element this function behaves like the overload taking a string, thus splitting it into "command" and "arguments". \ executeNoSplit( command : String[], stdin : String ); Same as above, except that `command` is an array of strings, where the first item is the name of the program and the following items are command line arguments. This version is useful if you have arguments that contain spaces or other characters that would need to be quoted if you just passed a single string command line, since it takes care of the quoting for you. This function never splits the first argument, regardless of the number of strings in the command array.

### Constructor

- Process(); Creates a Process object without specifying the program or any arguments. This does not start a process.

- Process( command : String ); Creates a Process object that will execute `command.` This does not start the process.

- Process( command : String[] ); Same as above, except that command is an array of strings, where the first item is the name of the program and the following items are command line arguments. This version is useful if you have arguments that contain spaces or other characters that would need to be quoted if you just passed a single string command line, since it takes care of the quoting for you.

### Properties

- arguments : String[]; Contains an array of strings where the first item is the program to execute and the following items are the command line arguments.

- workingDirectory : String; Contains the working directory for the process.

- running : Boolean; True if the process is currently running; otherwise false. This property is read-only.

- exitStatus : Number; Contains the exitStatus of the program when it has finished. This property is read-only.

### Member Functions

- start( env : String[] ); Tries to run a process for the command and arguments that were specified with the `argument` property or that were specified in the constructor. The command is searched for in the path for executable programs; you can also use an absolute path in the command itself. If `env` is not specified, the process is started with the same environment as the starting process. If `env` is specified, then the values in the `env` stringlist are interpreted as environment setttings of the form `VARIABLE=VALUE` and the process is started with these environment settings. If the program could not be started, an exception is thrown.

- launch( stdin : String, env : String[] ); Runs the process and writes the data `stdin` to the process's standard input. If all the data is written to standard input, standard input is closed. The command is searched for in the path for executable programs; you can also use an absolute path in the command itself. If `env` is unspecified, the process is started with the same environment as the starting process. If `env` is specified, then the values in the string list are interpreted as environment setttings of the form VARIABLE=VALUE and the process is started with these environment settings. If the program could not be started, an exception is thrown.

- readStdout() : String; Reads what is currently available on the process's standard output.

- readSterr() : String; Reads what is currently available on the process's standard error.

- canReadLineStdout() : Boolean; Returns true if a line can be read from the process's standard output.

- canReadLineStderr() : Boolean; Returns true if a line can be read from the process's standard error.

- readLineStdout() : String; Reads one line of text from the process's standard output if available; otherwise returns an empty string.

- readLineStderr() : String; Reads one line of text from the process's standard error if available; otherwise returns an empty string.

- tryTerminate(); Asks the process to terminate. Processes can ignore this if they wish. If you want to be certain that the process really terminates, you can use `kill()` instead.

- kill(); Terminates the process. This is not a safe way to end a process since the process will not be able to do any cleanup. `tryTerminate()` is safer, but processes can ignore `tryTerminate().`

- writeToStdin( buffer : String ); Writes the data `buffer` to the process's standard input. The process may or may not read this data.

- closeStdin(); Closes the process's standard input.